#!/usr/bin/python
# -*- coding: utf-8 -*-

#-------------------------------------------------------------------
#
# funktions:    webinterface for wav player,
#               upload wav files to folder $ROOT/wav
#
#
# use:          python <name>.py
#
# by:           emanuel@ihad.tv 2015
#
# -------------------------------------------------------------------
import sys
from os import rename as os_rename,\
    chmod as os_chmod,\
    write as os_write,\
    close as os_close,\
    unlink as os_unlink, \
    listdir as os_listdir, \
    system as os_system, \
    path as os_path, \
    makedirs as os_makedirs
        
from shutil import move
from tempfile import mkstemp
from twisted.internet import reactor
from twisted.web.resource import Resource
from twisted.web.server import Site, http
from twisted.web.static import File

NAME = os_path.basename(sys.argv[0])[:-3]
VERSION = "0.4"
APPHOME = "/usr/share/" + NAME
ENV = APPHOME + "/." + NAME
PLAYER = "audacious"
ARGS = "-h -p"

# setup env path, port
if os_path.exists(APPHOME):
    if os_path.exists(APPHOME + "/wav"):
        pass
    else:
        os_makedirs(APPHOME + "/wav")
else:
    os_makedirs(APPHOME)
    os_makedirs(APPHOME + "/wav")


if os_path.exists(ENV):
    with open(ENV,"r") as f:
        env = eval(f.read())
        LISTEN_PORT = int(env)
else:
    LISTEN_PORT = 8100
    with open(ENV, "w") as f:
        env = 8100
        f.write(str(env))

# fallback for translation
def _(bla):
    return bla

def mbasename(fname):
    l = fname.split('/')
    win = l[len(l)-1]
    l2 = win.split('\\')
    return l2[len(l2)-1]

class Upload(Resource):
    isLeaf = False
    res="""
        <?xml version="1.0" encoding="UTF-8"?>
        <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
                "http://www.w3.org/TR/html4/loose.dtd">
        <html>
        <head>
        <title>WAV Upload</title>
        <meta content="text/html; charset=UTF-8" http-equiv="content-type">
        <meta name="viewport" content="width=320", initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0, user-scalable=no">
        <link rel="shortcut icon" type="image/x-icon" href="/web-data/favicon.ico" />
        <link rel="stylesheet" href="/web-data/style.css">
        <script type="text/javascript">
        </script>
        </head>
        <body onunload="javascript:opener.location.reload()" >
        <h2>WAV Upload</h2>
        <p>%s</p>
        <form>
        <br/>
        <input type="button" value="WAV Upload" onClick="javascript:location='/upload'";>
        <br/>
        <br/>
        <input type="button" value="Player" onClick="javascript:location='..'";>
        </form>
        </body>
        </html>
        """
            
            
    def render_POST(self, req):
        if "file" not in req.args:
            req.setResponseCode(http.OK)
            return self.res %   _("error no file uploaded")
        
        if "filename" not in req.args:
            req.setResponseCode(http.OK)
            return self.res %   _("error no file uploaded")
        
        data = req.args['file'][0]
        filename = mbasename(req.args['filename'][0])
        print "%s: [filename] %s" %(NAME, filename)
            
        if not filename.endswith(".wav"):
            if filename == "":
                return self.res % _("error no file selected")
            return self.res % _("error wrong filetype!")
        
        if not data:
            req.setResponseCode(http.OK)
            return self.res %  _("error filesize was 0, not uploaded")
        
        fd,fn = mkstemp(dir = "/tmp/")
        cnt = os_write(fd, data)
        os_close(fd)
        os_chmod(fn, 0755)
        
        if cnt <= 0: # well, actually we should check against len(data) but lets assume we fail big time or not at all
            try:
                os_unlink(fn)
            except OSError, oe:
                pass
            req.setResponseCode(http.OK)
            return  self.res %_("error writing to disk, not uploaded")
        
        else:
            file = "/tmp/" + filename
            os_rename(fn,(file))
            if file is not None:
                move(file, APPHOME + "/wav/" + filename)
            else:
                return  self.res % _("error writing to disk, not uploaded")

            req.setResponseCode(http.OK)
            return self.res % ("upload ok")

    def render_GET(self, req):
        req.setResponseCode(http.OK)
        req.setHeader('Content-type', 'text/html')
        return """
                <?xml version="1.0" encoding="UTF-8"?>
                <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
                        "http://www.w3.org/TR/html4/loose.dtd">
                <html>
                <head>
                <title>WAV Upload</title>
                <meta content="text/html; charset=UTF-8" http-equiv="content-type">
                <meta name="viewport" content="width=320", initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0, user-scalable=no">
                <link rel="shortcut icon" type="image/x-icon" href="/web-data/favicon.ico" />
                <link rel="stylesheet" href="/web-data/style.css">
                <script type="text/javascript">
                function getWavFilename(){
                    var frm = document.forms["form_uploadwave"];
                    frm.filename.value = frm.file.value;
                }
                </script>
                </head>
                <body>
                <h2>WAV Upload</h2>
                <br/>
                <body onunload="javascript:opener.location.reload()" onload="window.scrollBy(0,1000000);" >
                <form name="form_uploadwave" method="POST" enctype="multipart/form-data">
                <input style="font-size: 18px; width: 300px; " name="file" type="file" size="50" maxlength="100000" accept="text/*" onchange="getWavFilename();">
                <br/>
                <br/>
                <input type="hidden" name="filename" value="">
                <br/>
                <input type="submit">
                <br/>
                <br/>
                <input type="button" value="Player" onClick="javascript:location='..'";>
                </form>
                </body>
                </html>
                """
        
class Player(Resource):
    isLeaf = False

    def render_GET(self, req):
        if "stop" in req.args:
            com = "amixer -c 1 set Speaker,0 center 0% woofer 0% rear 0%"
            os_system('%s' %com)
            com = PLAYER + " -h -s"
            os_system('%s &' %com)
            
        if "file" in req.args:
            file = req.args['file'][0]
            com = "amixer -c 1 set Speaker,0 center 0% woofer 0% rear 0%"
            os_system('%s' %com)
            #com = "killall -9 " + PLAYER
            #os_system('%s &' %com)
            
            com = "%s %s %s/wav/%s" %(PLAYER, ARGS, APPHOME, file)
            os_system('%s &' %com)
            
            com = "sleep 0.13; amixer -c 1 set Speaker,0 center 100% woofer 100% rear 100%"
            os_system('%s &' %com)        

        req.setResponseCode(http.OK)
        req.setHeader('Content-type', 'text/html')
        index = 0
        html = """
            <?xml version="1.0" encoding="UTF-8"?>
            <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
                    "http://www.w3.org/TR/html4/loose.dtd">
            <html>
            <head>
            <title>WAV Player</title>
            <meta content="text/html; charset=UTF-8" http-equiv="content-type" />
            <meta name="viewport" content="width=320", initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0, user-scalable=no" />
            <link rel="shortcut icon" type="image/x-icon" href="/web-data/favicon.ico" />
            <link rel="stylesheet" href="/web-data/style.css">
            </head>
            <body>
            <h2>WAV Player</h2>
            <input style="color: #FFFFFF; background: #F5003D;" type="button" value="Stop" onClick="javascript:location='/?stop=bla'">
            <br/>
            <br/>
            Playlist:
            <table style="width: 305px; border: 1px solid #AAA;font-size: 24px" >
            """
        for file in os_listdir(APPHOME + "/wav"):
            index += 1
            if file.endswith(".wav") or file.endswith(".WAV"):
                html += '<tr><td><a href="?file=%s">%d. %s</a></td></tr>\n' %(file, index, file)
        os_system('amixer -c 1 sset Speaker,0 unmute')        
        return html + """
                    </table>
                    <br/>
                    <input type="button" value="WAV Upload" onClick="javascript:location='/upload'";>
                    <br/>
                    </body>
                    </html>
                    """

def main():
    print """starting Webserver %s Vers. %s ...
Listen to port: %d
Root directory: %s""" %(NAME, VERSION, LISTEN_PORT, APPHOME + "/wav")
    
    root = Resource()
    upload = Upload()
    player = Player()

    root.putChild("web-data", File("/usr/share/" + NAME + "/web-data"))
    root.putChild("wav", File(APPHOME +" /wav"))
    root.putChild('upload', upload)
    root.putChild('', player)

    site = Site(root)
    reactor.listenTCP(LISTEN_PORT, site)
    reactor.run()

if __name__ == '__main__':
    main()

